<?php 
// Welcome to 乐众系统&IDC财务管理系统
// Copyright (c)  http://www.lzsys.com/ All rights reserved.
// Business authorization email server@lzsys.com
// 欢迎使用乐众系统&IDC财务管理系统
// [微信支付应用 功能模块]
if ($addons_config['path'] <> "weixin") {
    error();
} 

/**
 * -----接口通讯检测
 */
function weixin_status_vhost($plugin) {
    $status = array('status' => false, 'msg' => "支付渠道不支持检测", 'data' => array());

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 

/**
 * -----调起支付   PC版
 */
function weixin_pc_pay($plugin) {
    $asset_data = $plugin->asset_data();
    $api_config = $plugin->api_config();
    $appid = $api_config['remark']['appid'];
    $mchid = $api_config['remark']['mchid'];
    $apikey = $api_config['remark']['apikey'];
    $secret = $api_config['remark']['secret'];
    if($asset_data['money']<$api_config['remark']['money']){exit("充值金额不能低于￥".$api_config['remark']['money']."元");}
    $name = "客户号-" . $asset_data['user_data']['mobile'] . "充值金额-" . $asset_data['money'];
    define('WX_API_APPID', $appid);      #由于无法直接传变量到微信的class对象中，所以这里直接将 APPID定义成常量 这样就可以全局通用
    define('WX_API_MCHID', $mchid);      #由于无法直接传变量到微信的class对象中，所以这里直接将 商户号定义成常量 这样就可以全局通用
    define('WX_API_KEY', $apikey);       #由于无法直接传变量到微信的class对象中，所以这里直接将 商户密钥定义成常量 这样就可以全局通用
    define('WX_API_APPSECRET', $secret); #由于无法直接传变量到微信的class对象中，所以这里直接将 secret定义成常量 这样就可以全局通用
    $is_defend = true;

    require("wxpay/WxPay.Api.php");
    require("wxpay/WxPay.NativePay.php");

    $notify = new NativePay();
    $input = new WxPayUnifiedOrder();
    $input->SetBody($name);
    $input->SetOut_trade_no($asset_data['orders']);
    $input->SetTotal_fee($asset_data['money'] * 100);
    $input->SetSpbill_create_ip($plugin->ide->lzsys_system->get_ip());
    $input->SetTime_start(date("YmdHis"));
    $input->SetTime_expire(date("YmdHis", time() + 600));
    $input->SetNotify_url($asset_data['pay_notify']);
    $input->SetTrade_type("NATIVE");
    $result = $notify->GetPayUrl($input);
    if ($result["result_code"] == 'SUCCESS') {
        $code_url = $result['code_url'];
    } else {
        $status = array('status' => false, 'msg' => '微信支付下单失败！[' . $result["err_code"] . '] ' . $result["err_code_des"], 'data' => array());
        return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
    } 

    $html_text = $code_url; // 二维码链接 
    $file = "plugin/pay/weixin/qrcode.html"; //系统会引入此文件  
    // type = qrcode  表示返回支付链接   系统会将支付链接转换成二维码  客户扫码扫码即可
    // $html_text  这个是进行跳转支付的HTML代码 $html_text   调用成功后将代码放到  data数组下面 系统自动调用该代码
    if ($html_text) {
        $status = array('status' => true, 'msg' => "调起支付成功", 'data' => array("type" => "qrcode", "data" => $html_text, "file" => $file));
    } else {
        $status = array('status' => false, 'msg' => "调起支付失败", 'data' => array());
    } 

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 

/**
 * -----调起支付   H5版
 */
function weixin_h5_pay($plugin) {
    $asset_data = $plugin->asset_data();
    $api_config = $plugin->api_config();
    $appid = $api_config['remark']['appid'];
    $account = $api_config['remark']['account'];
    $secret = $api_config['remark']['secret'];
    if($asset_data['money']<$api_config['remark']['money']){exit("充值金额不能低于￥".$api_config['remark']['money']."元");}
    $name = "客户号-" . $asset_data['user_data']['mobile'] . "充值金额-" . $asset_data['money'];

    $html_text = "h5";
    $file = "plugin/pay/weixin/h5.php"; //系统会引入此文件  你可以在此文件中继续写PHP代码 
    // $html_text  返回任意值，type=qrcode 表示二维码模式，
    if ($html_text) {
        $status = array('status' => true, 'msg' => "调起支付成功", 'data' => array("type" => "qrcode", "data" => $html_text, "file" => $file));
    } else {
        $status = array('status' => false, 'msg' => "调起支付失败", 'data' => array());
    } 

    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 
/**
 * -----同步回调方法  只需要做签名验证 其他的过程系统智能完成
 */
function weixin_return($plugin) {
    $asset_data = $plugin->asset_data();
    $api_config = $plugin->api_config();
    $appid = $api_config['remark']['appid'];
    $account = $api_config['remark']['account'];
    $secret = $api_config['remark']['secret'];
    $get_orders = $asset_data['get']['out_trade_no']; // 本系统订单号
    $get_order = $asset_data['get']['trade_no']; // 支付宝官方订单号
    $html_text = "充值成功"; // 返回说明
    /**
     * 通常只做异步回调，同步回调无需开发 所以这里直接返回成功数据 type=HTML 告诉系统 输出HTML代码
     */

    $status = array('status' => true, 'msg' => "验证成功", 'data' => array("type" => "HTML", "data" => $html_text));
    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
} 
/**
 * -----异步回调方法  只需要做签名验证 其他的过程系统智能完成
 */
function weixin_notify($plugin) {
    $asset_data = $plugin->asset_data();
    $api_config = $plugin->api_config();
    $appid = $api_config['remark']['appid'];
    $account = $api_config['remark']['account'];
    $secret = $api_config['remark']['secret'];
    $xml = file_get_contents("php://input");
    $jsons = json_encode(simplexml_load_string($xml, 'SimpleXMLElement', LIBXML_NOCDATA));
    $arr = json_decode($jsons, true);
	
    $get_orders = $arr['out_trade_no']; // 本系统订单号
    $get_order = $arr['trade_no']; // 微信官方订单号 
	
    $appid = $api_config['remark']['appid'];
    $mchid = $api_config['remark']['mchid'];
    $apikey = $api_config['remark']['apikey'];
    $secret = $api_config['remark']['secret'];

    define('WX_API_APPID', $appid);
    define('WX_API_MCHID', $mchid);
    define('WX_API_KEY', $apikey);
    define('WX_API_APPSECRET', $secret);
	
    define('get_orders', $get_orders);
    define('get_order', $get_order);

	
    require("wxpay/WxPay.Api.php");
    require("wxpay/WxPay.Notify.php");
	
    class PayNotifyCallBack extends WxPayNotify {
        // 查询订单
        public function Queryorder($transaction_id) {
            $input = new WxPayOrderQuery();
            $input->SetTransaction_id($transaction_id);
            $result = WxPayApi::orderQuery($input); 
            // Log::DEBUG("query:" . json_encode($result));
            if (array_key_exists("return_code", $result) && array_key_exists("result_code", $result) && $result["return_code"] == "SUCCESS" && $result["result_code"] == "SUCCESS") {
                return true;
            } 
			
            return false;
        } 
        // 重写回调处理函数
        public function NotifyProcess($data, &$msg) {
            // file_put_contents('log.txt',"call back:" . json_encode($data));
            $notfiyOutput = array();

            if (!array_key_exists("transaction_id", $data)) {
                $msg = "输入参数不正确";
				define('status', "False");
                return false;
            } 
            // 查询订单，判断订单真实性
            if (!$this->Queryorder($data["transaction_id"])) {
                $msg = "订单查询失败";
				define('status', "False");
                return false;
            } 
            global $DB, $date, $conf;
            if ($data['return_code'] == 'SUCCESS') {
                if ($data['result_code'] == 'SUCCESS') {
                    // 这里表示验证成功
                    define('status', "True");// 将成功信息写入常量
					
                } else {
                    $msg = '[' . $data['err_code'] . ']' . $data['err_code_des'];
					define('status', "False");
                    return false;
                } 
            } else {
                $msg = '[' . $data['return_code'] . ']' . $data['return_msg'];
				define('status', "False");
                return false;
            }
            define('status', "False");			
            return true;
        } 
    } 
    // Log::DEBUG("begin notify");
    $notify = new PayNotifyCallBack();
    $notify->Handle(false);


       if(status=="True"){   //读取常量判断是否成功
		   
        // 验证成功后
        // 需要把 本系统订单号写入 $orders_data['get_orders']  和 官方订单号写入 $orders_data['get_order'] 和 状态码 写入 $orders_data['code']
        // 余额充值 邮件短信通知等过程 系统会自动完成
        $orders_data['get_orders'] = get_orders;
        $orders_data['get_order'] = get_order;

        $orders_data['code'] = "success"; // 返回成功状态码 根据接口方的要求提供 
        $status = array('status' => true, 'msg' => "验证成功", 'data' => array("type" => "SERVER", "data" => $orders_data));

        return $plugin->system("status", $plugin->ide->lzsys_system->json($status));
		   
		   
	   }
    $status = array('status' => false, 'msg' => "验证失败", 'data' => array("type" => "HTML", "data" => $html_text));
    return $plugin->system("status", $plugin->ide->lzsys_system->json($status));	   

} 
